package org.apache.baremaps.api;

import org.apache.baremaps.model.ConfClasses;

import javax.ws.rs.*;
import javax.ws.rs.core.Response;

import io.swagger.annotations.*;

import java.io.InputStream;
import java.util.Map;
import java.util.List;
import javax.validation.constraints.*;
import javax.validation.Valid;

@Path("/conformance")
@Api(description = "the conformance API")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaJAXRSSpecServerCodegen", date = "2023-03-14T17:37:24.176539752Z[Etc/UTC]")public interface ConformanceApi {

    @GET
    @Produces({ "application/json" })
    @ApiOperation(value = "information about conformance classes that this API conforms to", notes = "List of all conformance classes specified in a specification that the server conforms to.", tags={ "Capabilities" })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "the URIs of all conformance classes supported by this API", response = ConfClasses.class),
        @ApiResponse(code = 400, message = "invalid or unknown query parameters", response = Void.class),
        @ApiResponse(code = 406, message = "The media types accepted by the client are not supported for this resource", response = Void.class) })
    Response getConformanceDeclaration();
}
