package org.apache.baremaps.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import javax.validation.constraints.*;
import javax.validation.Valid;

import io.swagger.annotations.*;
import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;



@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaJAXRSSpecServerCodegen", date = "2023-03-14T17:37:24.176539752Z[Etc/UTC]")public class MbLayer   {
  
  private @Valid String id;

public enum TypeEnum {

    FILL(String.valueOf("fill")), LINE(String.valueOf("line")), SYMBOL(String.valueOf("symbol")), CIRCLE(String.valueOf("circle")), HEATMAP(String.valueOf("heatmap")), FILL_EXTRUSION(String.valueOf("fill-extrusion")), RASTER(String.valueOf("raster")), HILLSHADE(String.valueOf("hillshade")), BACKGROUND(String.valueOf("background"));


    private String value;

    TypeEnum (String v) {
        value = v;
    }

    public String value() {
        return value;
    }

    @Override
    @JsonValue
    public String toString() {
        return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String value) {
        for (TypeEnum b : TypeEnum.values()) {
            if (b.value.equals(value)) {
                return b;
            }
        }
        throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
}

  private @Valid TypeEnum type;
  private @Valid List<Object> filter = new ArrayList<Object>();
  private @Valid String source;
  private @Valid String sourceLayer;
  private @Valid Object layout;
  private @Valid BigDecimal minzoom;
  private @Valid BigDecimal maxzoom;
  private @Valid Object paint;

  /**
   **/
  public MbLayer id(String id) {
    this.id = id;
    return this;
  }

  

  
  @ApiModelProperty(example = "1", required = true, value = "")
  @JsonProperty("id")
  @NotNull
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }/**
   **/
  public MbLayer type(TypeEnum type) {
    this.type = type;
    return this;
  }

  

  
  @ApiModelProperty(example = "fill", required = true, value = "")
  @JsonProperty("type")
  @NotNull
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }/**
   **/
  public MbLayer filter(List<Object> filter) {
    this.filter = filter;
    return this;
  }

  

  
  @ApiModelProperty(value = "")
  @JsonProperty("filter")
  public List<Object> getFilter() {
    return filter;
  }

  public void setFilter(List<Object> filter) {
    this.filter = filter;
  }/**
   **/
  public MbLayer source(String source) {
    this.source = source;
    return this;
  }

  

  
  @ApiModelProperty(example = "daraa", value = "")
  @JsonProperty("source")
  public String getSource() {
    return source;
  }

  public void setSource(String source) {
    this.source = source;
  }/**
   **/
  public MbLayer sourceLayer(String sourceLayer) {
    this.sourceLayer = sourceLayer;
    return this;
  }

  

  
  @ApiModelProperty(example = "vegetationsrf", value = "")
  @JsonProperty("source-layer")
  public String getSourceLayer() {
    return sourceLayer;
  }

  public void setSourceLayer(String sourceLayer) {
    this.sourceLayer = sourceLayer;
  }/**
   **/
  public MbLayer layout(Object layout) {
    this.layout = layout;
    return this;
  }

  

  
  @ApiModelProperty(value = "")
  @JsonProperty("layout")
  public Object getLayout() {
    return layout;
  }

  public void setLayout(Object layout) {
    this.layout = layout;
  }/**
   **/
  public MbLayer minzoom(BigDecimal minzoom) {
    this.minzoom = minzoom;
    return this;
  }

  

  
  @ApiModelProperty(value = "")
  @JsonProperty("minzoom")
  public BigDecimal getMinzoom() {
    return minzoom;
  }

  public void setMinzoom(BigDecimal minzoom) {
    this.minzoom = minzoom;
  }/**
   **/
  public MbLayer maxzoom(BigDecimal maxzoom) {
    this.maxzoom = maxzoom;
    return this;
  }

  

  
  @ApiModelProperty(value = "")
  @JsonProperty("maxzoom")
  public BigDecimal getMaxzoom() {
    return maxzoom;
  }

  public void setMaxzoom(BigDecimal maxzoom) {
    this.maxzoom = maxzoom;
  }/**
   **/
  public MbLayer paint(Object paint) {
    this.paint = paint;
    return this;
  }

  

  
  @ApiModelProperty(value = "")
  @JsonProperty("paint")
  public Object getPaint() {
    return paint;
  }

  public void setPaint(Object paint) {
    this.paint = paint;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MbLayer mbLayer = (MbLayer) o;
    return Objects.equals(this.id, mbLayer.id) &&
        Objects.equals(this.type, mbLayer.type) &&
        Objects.equals(this.filter, mbLayer.filter) &&
        Objects.equals(this.source, mbLayer.source) &&
        Objects.equals(this.sourceLayer, mbLayer.sourceLayer) &&
        Objects.equals(this.layout, mbLayer.layout) &&
        Objects.equals(this.minzoom, mbLayer.minzoom) &&
        Objects.equals(this.maxzoom, mbLayer.maxzoom) &&
        Objects.equals(this.paint, mbLayer.paint);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, type, filter, source, sourceLayer, layout, minzoom, maxzoom, paint);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MbLayer {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    filter: ").append(toIndentedString(filter)).append("\n");
    sb.append("    source: ").append(toIndentedString(source)).append("\n");
    sb.append("    sourceLayer: ").append(toIndentedString(sourceLayer)).append("\n");
    sb.append("    layout: ").append(toIndentedString(layout)).append("\n");
    sb.append("    minzoom: ").append(toIndentedString(minzoom)).append("\n");
    sb.append("    maxzoom: ").append(toIndentedString(maxzoom)).append("\n");
    sb.append("    paint: ").append(toIndentedString(paint)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


}

